<template>
  <v-container grid-list-md text-xs-center>
    <v-layout>
      <v-flex xs12>
        <v-card dark color="primary">
          <v-card-text class="px-0">
            <h2 v-if="moduleJson.labels">{{ moduleJson.labels.title }}</h2>
          </v-card-text>
        </v-card>
      </v-flex>
    </v-layout>
    <!-- <v-data-table :headers="labelList" :items="allNews" class="elevation-1"> -->
    <v-flex xs12 sm3 d-flex>
      <v-select v-model="selectedOrder" :items="['Ordre croissant', 'Ordre Décroissant', 'Date croissante', 'Date décroissante']" box label="Trier par" @change="changeOrder()"></v-select>
    </v-flex>
    <v-data-table :headers="labelList" :items="allNews" class="elevation-1" :rows-per-page-items="[25]">
      <template v-slot:items="props">
        <!-- {{ props.item[0] }} -->
        <td class="text-center text-xs-center">{{ props.item[0][5] }}</td>
        <td class="text-center text-xs-center">{{ props.item[0][4] }}</td>
        <td class="text-center text-xs-center">{{ props.item[0][6]["categorie"] }}</td>
        <td class="text-center text-xs-center">{{ props.item[0][6]["scat1"] }}</td>
        <td class="text-center text-xs-center">{{ props.item[0][6]["scat2"] }}</td>
        <td class="text-center text-xs-center">{{ props.item[0][6]["scat3"] }}</td>

        <td v-for="champ in props.item" :key="champ.id" class="text-center text-xs-center">
          <!-- champs de type switch -->
          <!-- Désactivé temporairement car pas lisible -->
          <!-- <v-switch v-model="champ[0]" v-if="champ[1] == 'switch'" readonly></v-switch> -->

          <!-- champs de type text -->
          <span v-if="champ[1] == 'titre'">{{ champ[0] }}</span>

          <!-- test champ prix -->
          <span v-if="champ[1] == 'prix'">{{ champ[0] }}</span>

          <!-- champs de type oui -->
          <v-checkbox v-if="champ[1] == 'oui' || champ[1] == 'switch'" v-model="champ[0]" color="success" input-value="true" readonly hide-details class="align-center justify-center"></v-checkbox>
        </td>

        <!-- entre ici -->
        <td class="text-center text-xs-center">
          <v-checkbox v-if="props.item[0][2]" v-model="props.item[0][2]" color="success" input-value="true" hide-details readonly class="align-center justify-center"></v-checkbox>
          <v-checkbox v-else v-model="props.item[0][2]" color="error" input-value="false" hide-details readonly class="align-center justify-center"></v-checkbox>
        </td>
        <!-- et ici -->
        <td class="text-xs-right">
          <v-layout row>
            <!--
            [NOTE] props.item[0][3] correspond a l'id que l'on a transmis dans le constructDataList
          -->
            <v-btn small color="error" fab dark @click="deleteFiche(props.item[0][3], props.index)">
              <v-icon>delete_outline</v-icon>
            </v-btn>

            <v-btn small color="info" fab dark @click="duplicateFiche(props.item[0][3], props.index)">
              <v-icon>file_copy</v-icon>
            </v-btn>

            <v-tooltip top>
              <template v-slot:activator="{ on }">
                <v-btn small color="info" fab dark v-on="on" @click="editFiche(props.item[0][3])">
                  <v-icon>border_color</v-icon>
                </v-btn>
              </template>
              <span>Editer</span>
            </v-tooltip>
          </v-layout>
        </td>
      </template>
    </v-data-table>

    <v-layout>
      <v-btn color="info" @click="create" v-if="labelsModule">{{ labelsModule.create }}</v-btn>
    </v-layout>
    <v-snackbar v-model="snackbar" :bottom="y === 'bottom'" :left="x === 'left'" :multi-line="mode === 'multi-line'" :right="x === 'right'" :timeout="timeout" :top="y === 'top'" :vertical="mode === 'vertical'" :color="color">
      {{ text }}
      <v-btn color="white" flat @click="snackbar = false">
        <v-icon>close</v-icon>
      </v-btn>
    </v-snackbar>
    <v-dialog v-model="dialog" persistent width="300">
      <v-card color="primary" dark>
        <v-card-text>
          Veuillez patienter
          <v-progress-linear indeterminate color="white" class="mb-0"></v-progress-linear>
        </v-card-text>
      </v-card>
    </v-dialog>
  </v-container>
</template>
<script>
// import axios from "axios";
// import jsonConfig from "@/config-data/config-products.json";
import jsonConfigBuilder from "@/config-data/config-products.json";

const URL_API = process.env.VUE_APP_URL_DISTANT_API;
// const URL_NEWS_COPY = URL_API + "api/popups/duplicate/";
// const URL_NEWS_DELETE = URL_API + "api/popups/delete/";
// const URL_NEWS_LIST = URL_API + "api/popups/list/"; //ok
// const URL_NEWS_LIST = URL_API + "api/livres/list/"; //ok

var URL_NEWS_COPY;
var URL_NEWS_DELETE;
var URL_NEWS_LIST;
// var URL_NEWS_LIST;

export default {
  mounted: function() {
    this.moduleName = this.$route.params.module;
    this.jsonConfigBuilder.forEach((mod, idx) => {
      if (mod.module === this.moduleName) {
        this.tableName = mod.tableName;
        this.moduleJson = mod;
      }
    });

    this.loadUrls();
    // recuperation des ressources dont nous avons besoin
    this.getInputLabel();
    this.getDataList();
    this.setGlobalLabels();
  },
  data() {
    return {
      // moduleName: null,
      tableName: null,
      moduleJson: {},
      labelsModule: {},
      labelList: [],
      // jsonConfig,
      jsonConfigBuilder,
      datas: [],
      allNews: [],
      listeDatas: [],
      propertiesRender: [],
      dialog: false,
      selectedOrder: "",

      // infos snackbar
      snackbar: false,
      y: "top",
      x: null,
      mode: "",
      timeout: 6000,
      text: "Hello, I'm a snackbar",
      color: "pink"
    };
  },
  methods: {
    loadUrls() {
      URL_NEWS_COPY = URL_API + "api/" + this.tableName + "/duplicate/";
      URL_NEWS_DELETE = URL_API + "api/" + this.tableName + "/delete/";
      URL_NEWS_LIST = URL_API + "api/" + this.tableName + "/list/";
    },
    setGlobalLabels() {
      if (this.moduleName) {
        this.labelsModule = this.moduleJson.labels;
      }
    },
    create() {
      if (this.moduleName) {
        this.$router.push("/admin/gestion-produits/" + this.moduleName + "/create");
      }
    },
    editFiche(idFiche) {
      this.$router.push("/admin/gestion-produits/" + this.moduleName + "/edit/" + idFiche);
    },
    duplicateFiche(idToCopy, idx) {
      this.dialog = true;

      // copie en bdd
      this.$axios
        .get(URL_NEWS_COPY + idToCopy)
        .then(response => {
          this.dialog = false;
          this.snackbar = true;
          this.text = "Fiche copié";
          this.allNews = [];
          this.getDataList();
        })
        .catch(error => {
          console.log("error", error);
          this.dialog = false;
          this.snackbar = true;
          this.text = "Erreur sur la copie";
        });
    },
    deleteFiche(idToDelete, idx) {
      this.dialog = true;
      // suppression dans la bdd
      this.$axios
        .delete(URL_NEWS_DELETE + idToDelete)
        .then(response => {
          // suppression graphique
          this.allNews.splice(idx, 1);
          this.dialog = false;
          this.snackbar = true;
          this.text = "Fiche supprimé";
        })
        .catch(error => {
          console.log("error", error);
          this.dialog = false;
          this.snackbar = true;
          this.text = "Erreur sur la suppression";
        });
    },
    getInputLabel() {
      // Construction des entêtes des tableaux

      // on remplit le debut du tableau d'entête (labelList)

      let creaNode = {};
      creaNode.text = "Création";
      creaNode.value = "action_key_name";
      creaNode.align = "center";
      creaNode.sortable = false;
      this.labelList.push(creaNode);

      let orderNode = {};
      orderNode.text = "Ordre";
      orderNode.value = "action_key_name";
      orderNode.align = "right";
      orderNode.sortable = false;
      this.labelList.push(orderNode);

      let catInfosNode = {};
      catInfosNode.text = "Catégorie";
      catInfosNode.value = "action_key_name";
      catInfosNode.align = "center";
      catInfosNode.sortable = false;
      this.labelList.push(catInfosNode);

      let scat1InfosNode = {};
      scat1InfosNode.text = "Niveau 2";
      scat1InfosNode.value = "action_key_name";
      scat1InfosNode.align = "center";
      scat1InfosNode.sortable = false;
      this.labelList.push(scat1InfosNode);

      let scat2InfosNode = {};
      scat2InfosNode.text = "Niveau 3";
      scat2InfosNode.value = "action_key_name";
      scat2InfosNode.align = "center";
      scat2InfosNode.sortable = false;
      this.labelList.push(scat2InfosNode);

      let scat3InfosNode = {};
      scat3InfosNode.text = "Niveau 4";
      scat3InfosNode.value = "action_key_name";
      scat3InfosNode.align = "center";
      scat3InfosNode.sortable = false;
      this.labelList.push(scat3InfosNode);

      this.moduleJson.config.forEach(el => {
        if (el.affiche == true) {
          let cellheader = {};
          cellheader.text = el.libelle;
          cellheader.value = el.libelle.toLowerCase() + "_key_name"; // la value OSEF mais obligatoire pour vuetify apriori :/ ...
          cellheader.align = "center";
          cellheader.sortable = false;
          this.labelList.push(cellheader);
        }
      });

      // add prix affiche
      this.moduleJson.prix.forEach(el => {
        if (el.affiche == true) {
          let cellheader = {};
          cellheader.text = el.libelle;
          cellheader.value = el.libelle.toLowerCase() + "_key_name"; // la value OSEF mais obligatoire pour vuetify apriori :/ ...
          cellheader.align = "center";
          this.labelList.push(cellheader);
        }
      });

      // on remplit le reste du tableau d'entête (labelList)
      let activeNode = {};
      let actionNode = {};
      activeNode.text = "Actif";
      activeNode.value = "actif_key_name"; // la value OSEF mais obligatoire pour vuetify apriori :/ ...
      activeNode.align = "center";
      activeNode.sortable = false;
      actionNode.text = "Action";
      actionNode.value = "action_key_name"; // la value OSEF mais obligatoire pour vuetify apriori :/ ...
      actionNode.align = "right";
      actionNode.sortable = false;
      this.labelList.push(activeNode);
      this.labelList.push(actionNode);
    },
    getDataList() {
      //récupération des données
      this.$axios
        .get(URL_NEWS_LIST + this.moduleName)
        .then(response => {
          console.log("raw liste", response.data);
          //construction de la liste des données du module
          this.constructDataList(response.data);
        })
        .catch(error => {
          console.log("error = ", error);
        });
    },
    constructDataList(response) {
      let tempArray = [];
      this.listeDatas = response.data;
      this.moduleJson.config.forEach(el => {
        // console.log("el", el)
        if (el.affiche == true) {
          let cellheader = {};
          cellheader.text = el.champs;
          cellheader.type = el.type;
          tempArray.push(cellheader);
        }
      });
      // prix affiche
      this.moduleJson.prix.forEach(el => {
        if (el.affiche == true) {
          let cellheader = {};
          cellheader.text = el.champs;
          cellheader.type = el.type;

          tempArray.push(cellheader);
        }
      });

      this.listeDatas.forEach(news => {
        let arrayPrice = [];
        let idx = 0;
        let blr = [];
        let ActifRef = JSON.parse(news.actif);
        let OrdreRef = JSON.parse(news.ordre);
        let JsonResPrix = JSON.parse(news.dataprix);

        for (var i in JsonResPrix.simplePrice) {
          var key = i;
          var val = JsonResPrix.simplePrice[i];
          for (var j in val) {
            var sub_key = j;
            var sub_val = val[j];
            arrayPrice[sub_key] = sub_val;
          }
        }

        tempArray.forEach((conf, idxConf) => {
          let JsonRes = JSON.parse(news.data);

          let tabCat = [];
          tabCat["categorie"] = JsonRes.categorie;
          tabCat["scat1"] = JsonRes.scat1;
          tabCat["scat2"] = JsonRes.scat2;
          tabCat["scat3"] = JsonRes.scat3;

          // let JsonResPrix = JSON.parse(news.dataprix);
          if (JsonRes.hasOwnProperty(conf.text)) {
            blr[idx] = [JsonRes[conf.text], conf.type, ActifRef, news.id, news.ordre, news.created_at, tabCat];
          }
          if (arrayPrice.hasOwnProperty(conf.text)) {
            blr[idx] = [arrayPrice[conf.text], conf.type, ActifRef, news.id, news.ordre, news.created_at, tabCat];
          }

          idx++;
        });

        //  blr[idx].push(tabCat)
        this.allNews.push(blr);
        // console.log("this.allNews", this.allNews)
      });
    },
    changeOrder() {
      switch (this.selectedOrder) {
        case "Ordre croissant":
          this.allNews = this.allNews.sort(function(a, b) {
            return parseFloat(a[0][4]) - parseFloat(b[0][4]);
          });
          break;
        case "Ordre Décroissant":
          this.allNews = this.allNews.sort(function(a, b) {
            return parseFloat(b[0][4]) - parseFloat(a[0][4]);
          });
          break;
        case "Date croissante":
          this.allNews = this.allNews.sort(function(a, b) {
            return new Date(a[0][5]) - new Date(b[0][5]);
          });
          break;
        case "Date décroissante":
          this.allNews = this.allNews.sort(function(a, b) {
            return new Date(b[0][5]) - new Date(a[0][5]);
          });
          break;
      }
      //
    }
  }
};
</script>
